import { Parser } from 'lezer';
import { LezerLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = Parser.deserialize({
  version: 13,
  states: "!|QYQPOOOeQPO'#CiOyQPO'#CmO!eQPO'#CfOOQO'#Cm'#CmQYQPOOOYQPO,58|OYQPO,58|OOQO,59R,59ROYQPO,59QOOQO-E6g-E6gOOQO1G.h1G.hO!jQPO1G.hO#RQPO1G.lOOQO7+$W7+$W",
  stateData: "#^~O`OSPOS~ORQOSSOTSO~OVUOWVOR]XS]XT]X^]X~ObWORaXSaXTaXVaXWaX^aXXaX~O[XO~OVUORUiSUiTUiWUi^UiXUi~OVUOWVOX^O~O",
  goto: "!UbPPPPPPcPPPcjPqPPPwZSOTUVXZROTUVXQTORYTSPOTQZUQ[VR]X",
  nodeNames: "⚠ LineComment Program Identifier String Boolean BinaryExpression And Or ) Function Keyword (",
  maxTerm: 18,
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "'X~RbXY!ZYZ!Z]^!Zpq!Zrs!lst#Zxy#iyz#n}!O#s!Q![#s![!]$X!]!^$^!c!d$i!d!q#s!q!r&V!r!}#s#R#S#s#T#o#s~!`S`~XY!ZYZ!Z]^!Zpq!Z~!oTOr!lrs#Os#O!l#O#P#T#P~!l~#TOS~~#WPO~!l~#^Q#Y#Z#d#h#i#d~#iOT~~#nO[~~#sOX~~#xTR~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~$^Ob~~$cQP~OY$^Z~$^~$nVR~}!O#s!Q![#s!c!p#s!p!q%T!q!}#s#R#S#s#T#o#s~%YVR~}!O#s!Q![#s!c!f#s!f!g%o!g!}#s#R#S#s#T#o#s~%vTV~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~&[VR~}!O#s!Q![#s!c!t#s!t!u&q!u!}#s#R#S#s#T#o#s~&xTR~W~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const papershiveLanguage = LezerLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false })
            }),
            foldNodeProp.add({
                Application: foldInside
            }),
            styleTags({
                Identifier: tags.string,
                Boolean: tags.bool,
                String: tags.string,
                LineComment: tags.lineComment,
                "( )": tags.paren,
                And: tags.keyword,
                Or: tags.keyword,
                Keyword: tags.keyword
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
function papershive() {
    return new LanguageSupport(papershiveLanguage);
}

export { papershive, papershiveLanguage };
